/** stationsearchwin.cpp
 * 最寄駅検索
 *
 * @copyright	(c)studio pahoo
 * @author		パパぱふぅ
 * @開発環境	MinGW C++ + cURL + OpenSSL + Boost C++ Libraries
 *					+ WebView2Loader.dll + Leaflet + OSM (+ GoogleMap)
 * @参考URL		https://www.pahoo.org/e-soul/webtech/cpp01/cpp01-15-01.shtm
 */
#include <iostream>
#include <fstream>
#include <stdio.h>
#include <stdlib.h>
#include <tchar.h>
#include <time.h>
#include <sstream>
#include <string>
#include <locale>
#include <regex>
#include <winsock2.h>
#include <windows.h>
#include <shlobj.h>
#include <commctrl.h>
#include <objbase.h>
#include <wrl.h>
#include <richedit.h>

#include <curl/curl.h>
#include <boost/format.hpp>
#include <boost/property_tree/xml_parser.hpp>
#include <boost/property_tree/json_parser.hpp>
#include <boost/algorithm/string.hpp>
#include "mystrings.h"
#include "apikey.h"
#include "WebView2.h"
#include "pahooWebView2.hpp"
#include "pahooGeocode.hpp"
#include "resource.h"

using namespace std;
using namespace boost;
using namespace boost::property_tree;

// 定数など ==================================================================
#define MAKER		"pahoo.org"				// 作成者
#define APPNAME		"stationsearchwin"		// アプリケーション名
#define APPNAMEJP	"最寄駅検索"			// アプリケーション名（日本語）
#define APPVERSION	"2.2.3"					// バージョン
#define APPYEAR		"2020-26"				// 作成年
#define REFERENCE	"https://www.pahoo.org/e-soul/webtech/cpp01/cpp01-15-01.shtm"	// 参考サイト

// ListViewItemの最大文字長：変更不可
#define MAX_LISTVIEWITEM	259

// ヘルプ・ファイル
#define HELPFILE	".\\etc\\help.chm"

// デフォルト保存ファイル名
#define SAVEFILE	"stationsearchwin.csv"

// マップID
#define MAP_ID			"map_id"
// 地図の大きさ
#define MAP_WIDTH		530		// 地図の幅（ピクセル）
#define MAP_HEIGHT		300		// 地図の高さ（ピクセル）
// 経度・緯度（初期値）
#define DEF_LONGITUDE	139.766667
double Longitude = DEF_LONGITUDE;
#define DEF_LATITUDE	35.681111
double Latitude  = DEF_LATITUDE;
// 地図拡大率（初期値）
#define DEF_ZOOM	13
int Zoom = DEF_ZOOM;
// 地図の種類（初期値）
#define DEF_MAPTYPE		"GSISTD"
string Maptype = DEF_MAPTYPE;

// 現在のインターフェイス
HINSTANCE hInst;

// アプリケーション・ウィンドウ
HWND hParent;

// WebView2ウィンドウ
HWND hWebView2;

// ICoreWebView2：pahooWebView2.cpp で定義する．
extern ICoreWebView2* webView2;

// テンポラリファイル名
char tmpFname[MAX_PATH + 1];
wchar_t wUri[MAX_PATH * 2 + 1];

// アプリケーション・ウィンドウ位置
unsigned hParent_X, hParent_Y;

// 検索キー格納用
string Query;

// エラー・メッセージ格納用【変更不可】
string ErrorMessage;

// UserAgent
string UserAgent;

// pahooGeocodeオブジェクト
pahooGeocode* pGC;

// WebView2ハンドラの動作を指定する．
enum class eAction {
	GetLatLong,				// 緯度・経度取得してブラウザ表示
	GetZoomType,			// 拡大率・マップタイプ取得してブラウザ表示
	GetLatLongZoomType,		// 緯度・経度・拡大率・マップタイプ取得してブラウザ表示
	Finish					// プログラム終了
};
eAction selectAction;

// バージョン情報
string Version = (boost::format(R"(
%1%  バージョン %2%

本アプリケーションはMIT Licenseです．
商用を含む無償利用が可能です．自由に改造できます．
再配布の際は，下記の著作権表記，およびURLと本使用条件を必ず明記してください．

　Copyright by (c)studio pahoo, %3%
　https://www.pahoo.org/

なお，本アプリケーションの利用または改造することによって生じた得失ついては一切関知いたしません．APIの変更・停止によって正常に機能しなくなる場合があります．また，二次利用先の組織・企業・団体の目的・内容・活動については一切関知いたしません．

本アプリケーションは，下記のライブラリ，フレームワーク，インターネット上のリソースを利用しています．
　MinGW（g++）／Boost C++ライブラリ／libcurl／OpenSSL+／
　WebView2Loader.dll／Leaflet／OpenStreetMap／Googleマップ／
　HeartRails Express
)")
% APPNAMEJP
% APPVERSION
% APPYEAR
).str();


// サブ・プログラム =====================================================
/**
 * パラメータの初期化
 * @param	なし
 * @return	なし
 */
void initParameter(void) {
	Query     = "";
	Longitude = DEF_LONGITUDE;
	Latitude  = DEF_LATITUDE;
	Zoom      = DEF_ZOOM;
	Maptype   = DEF_MAPTYPE;
	hParent_X = 0;
	hParent_Y = 0;
}

/**
 * パラメータの読み込み
 * @param	なし
 * @return	なし
 */
void loadParameter(void) {
	ptree pt;

	// 初期値設定
	initParameter();

	// XMLファイル読み込み
	try {
		xml_parser::read_xml(getMyPath(APPNAME) + APPNAME + ".xml", pt);

		// XML解釈
		try {
			// 形式チェック
			if (optional<string>str = pt.get_optional<string>("parameter")) {
			} else {
				return;
			}
			// パラメータ読み込み
			for (auto it : pt.get_child("parameter")) {
				string type= it.second.get_optional<string>("<xmlattr>.type").value();
				if (type == "latitude") {
					Latitude = stod(it.second.data());
				} else if (type == "longitude") {
					Longitude = stod(it.second.data());
				} else if (type == "zoom") {
					Zoom = stoi(it.second.data());
				} else if (type == "maptype") {
					Maptype = (string)it.second.data();
				} else if (type == "wx") {
					hParent_X = (unsigned)stoi(it.second.data());
				} else if (type == "wy") {
					hParent_Y = (unsigned)stoi(it.second.data());
				} else if (type == "query") {
					Query = utf8_sjis((string)it.second.data());
				}
			}
		// 解釈失敗したら初期値設定
		} catch (xml_parser_error& e) {
			initParameter();
			return;
		}
	// 読み込み失敗したら初期値設定
	} catch (xml_parser_error& e) {
		initParameter();
		return;
	}

	// アプリケーション・ウィンドウの位置（デスクトップ範囲外なら原点移動）
	HWND hDesktop = GetDesktopWindow();
	WINDOWINFO windowInfo;
	windowInfo.cbSize = sizeof(WINDOWINFO);
	GetWindowInfo(hDesktop, &windowInfo);
	if (hParent_X >= (unsigned)windowInfo.rcWindow.right) {
		hParent_X = 0;
	}
	if (hParent_Y >= (unsigned)windowInfo.rcWindow.bottom) {
		hParent_Y = 0;
	}
}

/**
 * パラメータの保存
 * @param	なし
 * @return	なし
 */
void saveParameter(void) {
#ifndef CMDAPP
	// アプリケーション・ウィンドウの位置取得
	WINDOWINFO windowInfo;
	windowInfo.cbSize = sizeof(WINDOWINFO);
	GetWindowInfo(hParent, &windowInfo);
	hParent_X = (unsigned)windowInfo.rcWindow.left;
	hParent_Y = (unsigned)windowInfo.rcWindow.top;
	if (hParent_X >= (unsigned)windowInfo.rcWindow.right) {
		hParent_X = 0;
	}
	if (hParent_Y >= (unsigned)windowInfo.rcWindow.bottom) {
		hParent_Y = 0;
	}
#endif

	char lng[SIZE_BUFF + 1], lat[SIZE_BUFF + 1];
	snprintf(lng, SIZE_BUFF, "%.5f", Longitude);
	snprintf(lat, SIZE_BUFF, "%.5f", Latitude);

	// XMLファイルへ書き込む
	ptree pt;
	ptree& child1 = pt.add("parameter.param", lat);
	child1.add("<xmlattr>.type", "latitude");
	ptree& child2 = pt.add("parameter.param", lng);
	child2.add("<xmlattr>.type", "longitude");
	ptree& child3 = pt.add("parameter.param", to_string(Zoom));
	child3.add("<xmlattr>.type", "zoom");
	ptree& child4 = pt.add("parameter.param", Maptype);
	child4.add("<xmlattr>.type", "maptype");
	ptree& child5 = pt.add("parameter.param", (string)to_string(hParent_X));
	child5.add("<xmlattr>.type", "wx");
	ptree& child6 = pt.add("parameter.param", (string)to_string(hParent_Y));
	child6.add("<xmlattr>.type", "wy");
	ptree& child7 = pt.add("parameter.param", sjis_utf8(Query));
	child7.add("<xmlattr>.type", "query");

	const int indent = 4;
	write_xml(getMyPath(APPNAME) + APPNAME + ".xml", pt, std::locale(),
		xml_writer_make_settings<std::string>(' ', indent));
}

/**
 * パラメータの削除
 * @param	なし
 * @return	なし
 */
void delParameter(void) {
	remove((getMyPath(APPNAME) + APPNAME + ".xml").c_str());

	// 初期値設定
	initParameter();
}

// WebAPI「HeartRails Express」 ==============================================

// 最寄駅情報
typedef struct _pstations {
	char id;					// 識別子
	std::wstring title;			// 駅名
	std::wstring line;			// 最寄駅の存在する路線名
	std::wstring distance;		// 指定の場所から最寄駅までの距離（精度は10ｍ）
	double latitude;			// 緯度
	double longitude;			// 経度
} pstations_t;

// クラス定義
class pahooHeartRailsExpress {

public:
// コンストラクタ
pahooHeartRailsExpress();
~pahooHeartRailsExpress();

std::wstring errmsg = L"";		// エラーメッセージ
std::string webapi = "";		// 直近で使用したWebAPIのURL

// 最寄駅情報
pstations_t Pstations[__SIZE_PPOINTS];

bool isError(void);
std::wstring getError(void);
void resetError(void);
void setError(std::wstring msg);
std::string getwebapi(void);

int getResults_Heartrails(double latitude, double longitude);

};

// pahooHeartRailsExpress:オブジェクト
pahooHeartRailsExpress* pHR;

/**
 * コンストラクタ
 */
pahooHeartRailsExpress::pahooHeartRailsExpress() {
}

// デストラクタ
pahooHeartRailsExpress::~pahooHeartRailsExpress() {
}

/**
 * エラー状況
 * @param	なし
 * @return	bool TRUE:異常／FALSE:正常
*/
bool pahooHeartRailsExpress::isError(void) {
	return this->errmsg.length() > 0;
}

/**
 * エラーメッセージ取得
 * @param	なし
 * @return	wstring 現在発生しているエラーメッセージ
*/
wstring pahooHeartRailsExpress::getError(void) {
	return this->errmsg;
}

/**
 * エラーをリセットする
 * @param	なし
 * @return	なし
*/
void pahooHeartRailsExpress::resetError(void) {
	errmsg = L"";
}

/**
 * エラーをセットする
 * @param	wstring msg エラーメッセージ
 * @return	なし
*/
void pahooHeartRailsExpress::setError(wstring msg) {
	errmsg = msg;
}

/**
 * 直近で使用したWebAPIのURL取得
 * @param	なし
 * @return	string URL
*/
string pahooHeartRailsExpress::getwebapi(void) {
	return this->webapi;
}

/**
 * HeartRails Express API から必要な情報を配列に格納する
 * @param	double latitude  緯度（世界測地系）
 * @param	double longitude 経度（世界測地系）
 * @return	int ヒット数／(-1)：エラー発生
*/
int pahooHeartRailsExpress::getResults_Heartrails(double latitude, double longitude) {
	char lng[SIZE_BUFF + 1], lat[SIZE_BUFF + 1];

	snprintf(lng, SIZE_BUFF, "%.5f", longitude);
	snprintf(lat, SIZE_BUFF, "%.5f", latitude);
	this->webapi = "http://express.heartrails.com/api/xml?method=getStations&x=" + (string)lng + "&y=" + (string)lat;
	static string contents = "";
	int httpStatus = 0;
	bool res = readWebContents(this->webapi, UserAgent, &contents, &httpStatus);
	if (res == FALSE) {
		this->errmsg = _SW("HeartRails Express APIの接続エラーが発生しました");
		return (-1);
	} else if ((httpStatus < 200) || (httpStatus > 299)) {
		ErrorMessage = "HeartRails Express APIの接続エラーが発生しました";
		return (-1);
	}

	// 配列の初期化
	for (int i = 0; i < __SIZE_PPOINTS; i++) {
		this->Pstations[i].id = 0;
		this->Pstations[i].title = this->Pstations[i].line = this->Pstations[i].distance = L"";
		this->Pstations[i].latitude = this->Pstations[i].longitude = 0.0;
	}

	// XML読み込み
	int cnt = 0;
	try {
		std::stringstream ss;
		ss << contents;
		ptree pt;
		xml_parser::read_xml(ss, pt);

		// 応答チェック
		if (optional<string>str = pt.get_optional<string>("response.station")) {
		} else {
			this->errmsg = _SW("HeartRails Geo APIの応答エラーが発生しました");
			return (-1);
		}

		// XML解釈
		try {
			for (auto it : pt.get_child("response")) {
				if (cnt >= __SIZE_PPOINTS) {
					break;
				}
				// 読み飛ばし
				if (it.first != "station") {
					continue;
				}
				// 最寄駅名
				if (optional<string>name = it.second.get_optional<string>("name")) {
					this->Pstations[cnt].title = _UW(name.value());
				}
				// 緯度
				if (optional<string>lat = it.second.get_optional<string>("y")) {
					this->Pstations[cnt].latitude = stod(lat.value());
				}
				// 経度
				if (optional<string>lng = it.second.get_optional<string>("x")) {
					this->Pstations[cnt].longitude = stod(lng.value());
				}
				// 路線
				if (optional<string>line = it.second.get_optional<string>("line")) {
					this->Pstations[cnt].line = _UW(line.value());
				}
				// 距離
				if (optional<string>distance = it.second.get_optional<string>("distance")) {
					this->Pstations[cnt].distance = _UW(distance.value());
				}
				// 識別子
				this->Pstations[cnt].id = {(char)(65 + cnt)};
				cnt++;
			}
		// XML解釈エラー
		} catch(ptree_bad_path& e) {
			this->errmsg = _SW("HeartRails Geo APIの検索エラーが発生しました");
			return (-1);
		}

	// 読み込みエラー
	} catch(xml_parser_error& e) {
		this->errmsg = _SW("HeartRails Geo APIの接続エラーが発生しました");
		return (-1);
	}
	contents.clear();

	return cnt;
}

/**
 * 地図に表示するインフォメーション作成
 * @param	int cnt 表示するインフォメーション数
 * @return	重複削除後のインフォメーション数
 */
int makeInformation(int cnt) {
	// 初期化
	for (int i = 0; i < __SIZE_PPOINTS; i++) {
		pGC->Ppoints[i].latitude = pGC->Ppoints[i].longitude = 0.0;
		pGC->Ppoints[i].title = pGC->Ppoints[i].address = pGC->Ppoints[i].description = L"";
		pGC->Ppoints[i].icon = "";
	}

	// インフォメーション作成
	int j = -1;
	for (int i = 0; i < cnt; i++) {
		// 直前の地点と緯度・経度が同じ
		if ((i > 0)
			&& (pHR->Pstations[i].latitude == pHR->Pstations[i - 1].latitude)
			&& (pHR->Pstations[i].longitude == pHR->Pstations[i - 1].longitude)) {
			pGC->Ppoints[j].latitude  = pHR->Pstations[i].latitude;
			pGC->Ppoints[j].longitude = pHR->Pstations[i].longitude;
			pGC->Ppoints[j].description += L"<br />" + pHR->Pstations[i].title
				+ _SW(" (") + pHR->Pstations[i].line + _SW(") ")
				+ pHR->Pstations[i].distance;
		// 緯度・経度が異なる
		} else {
			j++;
			pGC->Ppoints[j].latitude  = pHR->Pstations[i].latitude;
			pGC->Ppoints[j].longitude = pHR->Pstations[i].longitude;
			pGC->Ppoints[j].description = pHR->Pstations[i].title
				+ _SW(" (") + pHR->Pstations[i].line + _SW(") ")
				+ pHR->Pstations[i].distance;
		}
		// 識別子の振り直し
		pHR->Pstations[i].id = {(char)(65 + j)};
	}

	// 重複の削除
	for (int i = j + 1; i < __SIZE_PPOINTS; i++) {
		pGC->Ppoints[i].latitude = pGC->Ppoints[i].longitude = 0.0;
		pGC->Ppoints[i].title = pGC->Ppoints[i].address = pGC->Ppoints[i].description = L"";
		pGC->Ppoints[i].icon = "";
	}

	return j + 1;
}

// 地図表示（ブラウザ） ======================================================
/**
 * 地図表示用HTML生成
 * @param	int cnt 表示するインフォメーション数
 * @return	string 生成したHTML文
 */
string makeMapHTML(int cnt=0) {
	string script = pGC->makeMapLeaflet(MAP_ID, Longitude, Latitude, Zoom, Maptype, pGC->Ppoints, cnt);
	string html = (boost::format(R"(<!DOCTYPE html>
<html lang="ja">
<head>
<meta charset="SJIS">
<title>最寄駅検索</title>
<meta name="author" content="studio pahoo" />
<meta name="copyright" content="studio pahoo" />
<meta name="ROBOTS" content="NOINDEX,NOFOLLOW" />
<meta http-equiv="pragma" content="no-cache">
<meta http-equiv="cache-control" content="no-cache">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
%8%
</head>
<body>
<div id="%1%" style="width:%2%px; height:%3%px;"></div>
<form>
<input id="latitude"  type="hidden" value="%4%" />
<input id="longitude" type="hidden" value="%5%" />
<input id="zoom"      type="hidden" value="%6%" />
<input id="maptype"   type="hidden" value="%7%" />
</form>
</body>
</html>
)")
% MAP_ID						// 地図ID
% MAP_WIDTH						// 地図の幅
% MAP_HEIGHT					// 地図の高さ
% Latitude						// 緯度
% Longitude						// 経度
% Zoom							// 地図拡大率
% Maptype						// 地図タイプ
% script						// 地図描画スクリプト
).str();

	return html;
}

/**
 * エラーメッセージ表示用HTML生成
 * @param	なし
 * @return	string 生成したHTML文
 */
string makeErrorHTML(void) {
	string msg;
	if (pGC->isError()) {
		msg = _WS(pGC->getError());
	} else {
		msg = ErrorMessage;
	}
	return (boost::format(R"(<!DOCTYPE html>
<html lang="ja">
<head>
<meta charset="SJIS">
<title>エラー発生</title>
<meta name="author" content="studio pahoo" />
<meta name="copyright" content="studio pahoo" />
<meta name="ROBOTS" content="NOINDEX,NOFOLLOW" />
<meta http-equiv="pragma" content="no-cache">
<meta http-equiv="cache-control" content="no-cache">
</head>
<body>
<p style="color:red; font-size:large;">%1%</p>
</body>
</html>
)")
% msg
).str();
}

/**
 * ブラウザ・コントロールを表示
 * @param	char* tmpname 読み込むHTMLファイル名
 * @param	int cnt 表示するインフォメーション数
 * @return	なし
 */
void viewBrowser(const char *tmpname, int cnt=0) {
	string html;
	string fname;
	ofstream ofs;

	// 表示用HTMLファイル作成
	if ((ErrorMessage == "") && (! pGC->isError())) {
		html = makeMapHTML(cnt);
	} else {
		html = makeErrorHTML();
	}
	ofs.open(tmpname);
	ofs << html;
	ofs.close();

	fname = (string) tmpname;
	std::replace(fname.begin(), fname.end(), '\\', '/');

	if (isWeb2Ready()) {
		webView2->Reload();
	}
}

// 最寄駅一覧作成（リストビュー） =========================================
// リストビューの列
enum {
	COL_ID,
	COL_TITLE,
	COL_LINE,
	COL_DISTANCE
};

/**
 * 最寄駅の一覧表フレーム作成
 * @param	HWND hDlg  ウィンドウハンドル
 * @return	なし
*/
void makeListViewFrame(HWND hWnd) {
	LVCOLUMNA lvcol;
	lvcol.mask = LVCF_TEXT | LVCF_SUBITEM | LVCF_WIDTH | LVCF_FMT;

	lvcol.cx = 50;
	lvcol.fmt = LVCFMT_CENTER;
	lvcol.pszText = (char *)"ID";
	SendMessage(hWnd, LVM_INSERTCOLUMNA, COL_ID, (WPARAM)&lvcol);
	lvcol.cx = 150;
	lvcol.fmt = LVCFMT_LEFT;
	lvcol.pszText = (char *)"駅名";
	SendMessage(hWnd, LVM_INSERTCOLUMNA, COL_TITLE, (WPARAM)&lvcol);
	lvcol.cx = 200;
	lvcol.fmt = LVCFMT_LEFT;
	lvcol.pszText = (char *)"路線名";
	SendMessage(hWnd, LVM_INSERTCOLUMNA, COL_LINE, (WPARAM)&lvcol);
	lvcol.cx = 100;
	lvcol.fmt = LVCFMT_RIGHT;
	lvcol.pszText = (char *)"距離";
	SendMessage(hWnd, LVM_INSERTCOLUMNA, COL_DISTANCE, (WPARAM)&lvcol);

	// 罫線表示
	DWORD dwStyle = ListView_GetExtendedListViewStyle(hWnd);
	dwStyle = dwStyle | LVS_EX_GRIDLINES | LVS_EX_ONECLICKACTIVATE;
	ListView_SetExtendedListViewStyle(hWnd, dwStyle);
}

/**
 * 最寄駅の一覧表示
 * @param	HWND hDlg  ウィンドウハンドル
 * @return	なし
*/
void makeListView(HWND hWnd) {
	LVITEMA item;

	// 初期化
	for (int i = 0; i < __SIZE_PPOINTS; i++) {
		item.iItem = i;
		SendMessage(hWnd, LVM_DELETEITEM, 0, (WPARAM)&item);
	}

	// データ行
	for (int i = 0; i < __SIZE_PPOINTS; i++) {
		if (pHR->Pstations[i].id == 0) {
			break;
		}
		// ID
		item.mask = LVIF_TEXT;
		item.iItem = i;
		item.iSubItem = COL_ID;
		string s = {pHR->Pstations[i].id};
		item.pszText = (LPSTR)(s.c_str());
		SendMessage(hWnd, LVM_INSERTITEMA, 0,(WPARAM)&item);
		// 駅名
		item.iSubItem = COL_TITLE;
		item.pszText = (LPSTR)_WS(pHR->Pstations[i].title).substr(0, MAX_LISTVIEWITEM).c_str();
		SendMessage(hWnd, LVM_SETITEMA, 0,(WPARAM)&item);
		// 路線名
		item.iSubItem = COL_LINE;
		item.pszText = (LPSTR)_WS(pHR->Pstations[i].line).substr(0, MAX_LISTVIEWITEM).c_str();
		SendMessage(hWnd, LVM_SETITEMA, 0,(WPARAM)&item);
		// 距離
		item.iSubItem = COL_DISTANCE;
		item.pszText = (LPSTR)_WS(pHR->Pstations[i].distance).substr(0, MAX_LISTVIEWITEM).c_str();
		SendMessage(hWnd, LVM_SETITEMA, 0,(WPARAM)&item);
	}
}

/**
 * 最寄駅を検索し，ブラウザ表示と一覧表示を行う．
 * @param	HWND hDlg  ウィンドウハンドル
 * @return	なし
*/
void viewMapList(void) {
	int cnt = 0;

	// 最寄駅検索
	cnt = pHR->getResults_Heartrails(Latitude, Longitude);
	if (cnt > 0) {
		cnt = makeInformation(cnt);
	}

	// ブラウザ・コントロールに表示
	viewBrowser(tmpFname, cnt);

	// 最寄駅の一覧表示
	makeListView(GetDlgItem(hParent, IDC_LISTVIEW_STATIONS));
}

// 保存・コピー =============================================================
/**
 * 一覧情報をCSVファイルに保存する：保存処理
 * @param	const char* fname 保存ファイル名
 * @return	なし
 */
void __saveCSV(const char *fname) {
	char lng[SIZE_BUFF + 1], lat[SIZE_BUFF + 1];
	ofstream outputfile(fname);

	// ラベル
	outputfile << "\"" << "ID" << "\",";
	outputfile << "\"" << "駅名" << "\",";
	outputfile << "\"" << "路線名" << "\",";
	outputfile << "\"" << "緯度" << "\",";
	outputfile << "\"" << "経度" << "\",";
	outputfile << "\"" << "距離" << "\"" << endl;

	// データ本体
	for (int i = 0; i < __SIZE_PPOINTS; i++) {
		if (pHR->Pstations[i].id != 0) {
			snprintf(lng, SIZE_BUFF, "%.5f", pHR->Pstations[i].longitude);
			snprintf(lat, SIZE_BUFF, "%.5f", pHR->Pstations[i].latitude);
			outputfile << "\"" << pHR->Pstations[i].id << "\",";
			outputfile << "\"" << _WS(pHR->Pstations[i].title) << "\",";
			outputfile << "\"" << _WS(pHR->Pstations[i].line) << "\",";
			outputfile << "\"" << lat << "\",";
			outputfile << "\"" << lng << "\",";
			outputfile << "\"" << _WS(pHR->Pstations[i].distance) << "\"" << endl;
		}
		if (outputfile.bad()) {
			ErrorMessage = "CSVファイル書き込みエラー";
			break;
		}
	}
	outputfile.close();
}

/**
 * 一覧情報をCSVファイルに保存する：ファイルダイアログ
 * @param	なし
 * @return	なし
 */
void saveCSV(void) {
	static char fname[MAX_PATH + 1];
	strcpy(fname, SAVEFILE);
	OPENFILENAME of;

	// OPENFILENAME構造体のサイズをセット
	memset(&of, 0, sizeof(OPENFILENAME));
	of.lStructSize = sizeof(OPENFILENAME);
	// ダイアログボックスを所有するウィンドウへのハンドル
	of.hwndOwner = hParent;
	of.lpstrFilter = TEXT("CSVファイル(*.csv;*.txt)\0*.csv;*.txt\0すべてのファイル(*.txt)\0*.txt\0\0");
	// ファイル名を格納したバッファのアドレス
	of.lpstrFile = (LPTSTR)fname; 
	// lpstrFileメンバで指定されるバッファのサイズ
	of.nMaxFile = MAX_PATH;
	of.Flags = OFN_OVERWRITEPROMPT;
	// デフォルトの拡張子を格納したバッファのアドレス
	of.lpstrDefExt = TEXT("csv");
	// コモンダイアログの表示
	GetSaveFileName(&of);
	// ファイル保存
	__saveCSV(fname);
}

/**
 * クリップボードにコピーする文字列を生成
 * @param	なし
 * @return	string コピーする文字列
 */
string copyText(void) {
	char lng[SIZE_BUFF + 1], lat[SIZE_BUFF + 1];
	ostringstream oss;

	// ラベル
	oss << "ID" << "\t";
	oss << "駅名" << "\t";
	oss << "路線名" << "\t";
	oss << "緯度" << "\t";
	oss << "経度" << "\t";
	oss << "距離" << endl;

	// データ本体
	for (int i = 0; i < __SIZE_PPOINTS; i++) {
		if (pHR->Pstations[i].id != 0) {
			snprintf(lng, SIZE_BUFF, "%.5f", pHR->Pstations[i].longitude);
			snprintf(lat, SIZE_BUFF, "%.5f", pHR->Pstations[i].latitude);
			oss << pHR->Pstations[i].id << "\t";
			oss << _WS(pHR->Pstations[i].title) << "\t";
			oss << _WS(pHR->Pstations[i].line) << "\t";
			oss << lat << "\t";
			oss << lng << "\t";
			oss << _WS(pHR->Pstations[i].distance) << endl;
		}
	}
	return oss.str();
}


// バージョン表示ダイアログ =================================================
/**
 * イベントハンドラ：バージョン表示ダイアログ
 * @param	HWND hDlg			ウィンドウ・ハンドラ
 * @paramm	UINT uMsg			メッセージ識別子
 * @param	WPARAM wParam		メッセージの最初のパラメータ
 * @paramL	PARAM lParam		メッセージの2番目のパラメータ
 * @return	INT_PTR CALLBACK	TRUE：メッセージ処理完了／FALSE：未完了
 */
INT_PTR CALLBACK processHelp(HWND hDlg, UINT uMsg,
					WPARAM wParam, LPARAM lParam) {
	string help;

	switch (uMsg) {
	// ダイアログ初期化
	case WM_INITDIALOG:
		CenterWindow(hDlg);
		setStrEditBox(hDlg, IDC_TEXT_HELP, Version);
		break;

		// ボタン押下
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		// 実行
		case IDC_BUTTON_OK:
			EndDialog(hDlg, 0);
			break;
		default:
			return 1;
		}
		break;
		// プログラム終了
	case WM_CLOSE:
		EndDialog(hDlg, 0);
		break;
	}
	return 0;
}

/**
 * ヘルプ・ダイアログを作成
 * @param  HWND hDlg		親ウィンドウ・ハンドラ
 * @param  DLGPROC handler	イベント・ハンドラ
 * @return なし
 */
void createHelp(HWND hDlg, DLGPROC handler) {
	DialogBox(hInst, MAKEINTRESOURCE(IDD_DIALOG_VER), hDlg, (DLGPROC) handler);
}

// WebView2制御用関数群 ======================================================
/**
 * WebView2：ダイアログを初期化する
 * @param	HWND hDlg	親ウィンドウ・ハンドラ
 * @return	なし
*/
void initDialog(HWND hDlg) {
	HICON hIcon;
	hIcon = (HICON)LoadImage(hInst, MAKEINTRESOURCE(IDI_ICON), IMAGE_ICON, 16, 16, 0);
	SendMessage(hDlg, WM_SETICON, ICON_SMALL, (LPARAM)hIcon);
	ErrorMessage = "";

	// カーソルを砂時計に
	SetCursor(LoadCursor(NULL, IDC_WAIT));
	// オプション読み込み
	loadParameter();
	// アプリケーション・ウィンドウ移動
	SetWindowPos(hDlg, NULL, hParent_X, hParent_Y, 0, 0, (SWP_NOSIZE | SWP_NOZORDER | SWP_NOOWNERZORDER));

	// テンポラリ・ファイル名取得
	getTempFname(tmpFname);
	size_t wLen = 0;
	mbstowcs_s(&wLen, wUri, MAX_PATH * 2, tmpFname, MAX_PATH);
	// WebView2生成
	hWebView2 = createWebView2(hInst, hDlg, 10, 50, MAP_WIDTH + 30, MAP_HEIGHT + 30, wUri);
	// 最寄駅の一覧表フレーム作成
	makeListViewFrame(GetDlgItem(hDlg, IDC_LISTVIEW_STATIONS));

	// Leafletが利用可能かどうか調べる
	const string url = "https://unpkg.com/leaflet@latest/";
	string contents = "";
	int httpStatus = 0;
	bool res = readWebContents(url, UserAgent, &contents, &httpStatus);
	if (res == FALSE) {
		ErrorMessage = "地図描画ライブラリ（Leaflet）が利用できません";
	} else if ((httpStatus < 200) || (httpStatus > 299)) {
		ErrorMessage = "地図描画ライブラリ（Leaflet）が利用できません";
	}

	// メッセージ・ループ
	MSG msg;
	static bool flagWebView2 = false;
	while (GetMessage(&msg, nullptr, 0, 0)) {
		if (msg.message == WM_QUIT) {
			// オプション保存
			// saveOption();
			DestroyWindow(hDlg);
		}
		TranslateMessage(&msg);
		DispatchMessage(&msg);
		if (!flagWebView2 && isWeb2Ready()) {
			// カーソルを砂時計に
			SetCursor(LoadCursor(NULL, IDC_WAIT));
			// ブラウザ表示と一覧表示
			viewMapList();
			flagWebView2 = true;
		}
	}
}

/**
 * WebView2ハンドラ処理．
 * selectActionの値によって動作を変える。
 * @param	char* result	JavaScript終了ハンドラから渡るデータ
 * @return	なし
*/
void execScriptCompleted(string result) {
	double lat = 0, lng = 0;
	int zm = 0;
	string mt;

	// パラメータを読み込む
	vector<string> tokens;
	split(tokens, result, is_any_of(",\""));
	int cnt = 0;
	for (string ss: tokens) {
		switch (cnt) {
			case 1:
				lng = stod(ss);
				break;
			case 2:
				lat = stod(ss);
				break;
			case 3:
				zm = stoi(ss);
				break;
			case 4:
				mt = ss;
				break;
		}
		cnt++;
	}

	switch (selectAction) {
		// 緯度・経度を取得してブラウザに表示
		case eAction::GetLatLong:
			Longitude = lng;
			Latitude  = lat;
			// ブラウザ表示と一覧表示
			viewMapList();
			break;
		// 拡大率・マップタイプを取得してブラウザに表示
		case eAction::GetZoomType:
			Zoom = zm;
			Maptype = mt;
			// ブラウザ表示と一覧表示
			viewMapList();
			break;
		// 緯度・経度・拡大率・マップタイプを取得してブラウザに表示
		case eAction::GetLatLongZoomType:
			Longitude = lng;
			Latitude  = lat;
			Zoom = zm;
			Maptype = mt;
			// ブラウザ表示と一覧表示
			viewMapList();
			break;
		// プログラムを終了する．
		default:
			Longitude = lng;
			Latitude  = lat;
			Zoom = zm;
			Maptype = mt;
			// テンポラリ・ファイルを削除する．
			remove(tmpFname);
			// パラメータを保存する．
			saveParameter();
			// プログラムを終了する
			EndDialog(hParent, 0);
			DestroyWindow(hParent);
			break;
	}
//	cout << "Longitude: " << Longitude << endl;
//	cout << "Latitude: " << Latitude << endl;
//	cout << "Zoom: " << Zoom << endl;
//	cout << "Maptype: " << Maptype << endl;
}

/**
 * WebView2：JavaScript終了ハンドラ
 * @param	HWND hDlg			親ウィンドウ・ハンドラ
 * @paramm	UINT uMsg			メッセージ識別子
 * @param	WPARAM wParam		メッセージの最初のパラメータ
 * @paramL	PARAM lParam		メッセージの2番目のパラメータ
 * @return	INT_PTR CALLBACK	TRUE：メッセージ処理完了／FALSE：未完了
*/
class MyScriptCompletedHandler : public ICoreWebView2ExecuteScriptCompletedHandler {
public:
	HRESULT STDMETHODCALLTYPE Invoke(HRESULT error, PCWSTR result) override {
		if (SUCCEEDED(error)) {
			// PCWSTR → char* 変換
			int requiredSize = WideCharToMultiByte(CP_UTF8, 0, result, -1, nullptr, 0, nullptr, nullptr);
			char* buffer = new char[requiredSize];
			WideCharToMultiByte(CP_UTF8, 0, result, -1, buffer, requiredSize, nullptr, nullptr);
			std::string res(buffer);
			// JavaScript終了時に実行する関数
			execScriptCompleted(res);
		}
		return S_OK;
	}

	HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, void** ppvObject) override {
		return E_NOINTERFACE;
	}

	ULONG STDMETHODCALLTYPE AddRef(void) override {
		return 1;
	}

	ULONG STDMETHODCALLTYPE Release(void) override {
		return 1;
	}
};

// WebView2のJavaScriptを実行してDOM要素を取得
MyScriptCompletedHandler* scriptCompletedHandler = new MyScriptCompletedHandler();

/**
 * WebView2でスクリプトを実行した後，selectActionで指定したアクションを実行する．
 * @param	なし
 * @return	なし
*/
void execScriptAndAction(void) {
	// プログラム終了時に実行するJavaScript
	LPCWSTR js = L"document.getElementById('longitude').value + ',' + document.getElementById('latitude').value + ',' + document.getElementById('zoom').value + ',' + document.getElementById('maptype').value;";

	webView2->ExecuteScript(js, scriptCompletedHandler);
}

// メインウィンドウ ==========================================================
/**
 * イベントハンドラ：メインウィンドウ
 * @param	HWND hDlg			親ウィンドウ・ハンドラ
 * @paramm	UINT uMsg			メッセージ識別子
 * @param	WPARAM wParam		メッセージの最初のパラメータ
 * @paramL	PARAM lParam		メッセージの2番目のパラメータ
 * @return	INT_PTR CALLBACK	TRUE：メッセージ処理完了／FALSE：未完了
 */
INT_PTR CALLBACK processMain(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	wstring val;
	wstring wid;

	switch (uMsg) {
	// ダイアログ初期化
	case WM_INITDIALOG:
		break;

	// ボタン押下
	case WM_COMMAND:
		if ((ErrorMessage != "") | pGC->isError()) {
			break;
		}
		switch (LOWORD(wParam)) {
		// 検索
		case IDM_EXEC:
		case IDC_BUTTON_EXEC:
			// カーソルを砂時計に
			SetCursor(LoadCursor(NULL, IDC_WAIT));
			// 検索キーがあればジオコードAPI呼び出し
			Query = getStrEditBox(hDlg, IDC_EDIT_QUERY);
			if (Query.length() > 0) {
				if (pGC->searchPoints(_SW(Query), UserAgent, 0) > 0) {
					Longitude = pGC->Ppoints[0].longitude;
					Latitude  = pGC->Ppoints[0].latitude;
				}
				// ブラウザ表示と一覧表示
				selectAction = eAction::GetZoomType;
				execScriptAndAction();
			} else {
				// ブラウザ表示と一覧表示
				selectAction = eAction::GetLatLongZoomType;
				execScriptAndAction();
			}
			// エラー・リセット
			ErrorMessage = "";
			pGC->resetError();
			break;
		// リセット
		case IDC_BUTTON_RESET:
		case IDM_RESET:
			setStrEditBox(hDlg, IDC_EDIT_QUERY, "");
			ErrorMessage = "";
			pGC->resetError();
			break;
		// 保存
		case IDC_BUTTON_SAVE:
		case IDM_SAVE:
			saveCSV();
			break;
		// GoogleAPIキー保存
		case IDM_GOOGLE_APIKEY:
			createSetAPIkey(hDlg, LABEL_GOOGLE_API, FNAME_GOOGLE_API, URL_GOOGLE_API, &pGC->GoogleAPIkey);
			pGC->readGoogleApiKey();
			// エラー・リセット
			ErrorMessage = "";
			pGC->resetError();
			// GoogleAPIキー未登録ならデフォルトのマップタイプに戻す．
			Maptype = pGC->isGoogleApiKey() ? "GMRD" : DEF_MAPTYPE;
			// ブラウザ・コントロールに表示
			viewBrowser(tmpFname);
			break;
		// Yahoo!アプリケーションID保存
		case IDM_YAHOO_APIKEY:
			createSetAPIkey(hDlg, LABEL_YAHOO_API, FNAME_YAHOO_API, URL_YAHOO_API, &pGC->YahooAPIkey);
			// エラー・リセット
			ErrorMessage = "";
			pGC->resetError();
			// ブラウザ・コントロールに表示
			viewBrowser(tmpFname);
			break;
		// 設定クリア＋アプリ終了
		case IDM_CLEAR_PARAMETER:
			delParameter();
			// テンポラリ・ファイル削除
			remove(tmpFname);
			EndDialog(hDlg, 0);
			return 0;
			break;
		// ヘルプ
		case IDM_HELP:
			ShellExecute(hDlg, _T("open"), _T(HELPFILE), NULL, NULL, SW_RESTORE);
			break;
		// バージョン表示
		case IDM_VERSION:
			createHelp(hDlg, processHelp);
			break;
		// 解説サイト
		case IDM_PAHOO:
			ShellExecute(NULL, _T("open"), _T(REFERENCE), NULL, NULL, SW_RESTORE);
			break;
		// コピー
		case IDM_COPY:
		case IDC_BUTTON_COPY:
			setClipboardData(copyText());
			break;
		// 切り取り
		case IDM_DELETE:
			setStrEditBox(hDlg, IDC_EDIT_QUERY, "");
			break;
		// プログラム終了
		case IDM_QUIT:
			selectAction = eAction::Finish;
			execScriptAndAction();
			return 0;
		default:
			return 0;
		}
		break;

	// プログラム終了
	case WM_CLOSE:
		selectAction = eAction::Finish;
		execScriptAndAction();
		return 0;
	}
	return 0;
}

// メイン・プログラム =======================================================
/**
 * Windowsメインプログラム
 * @param	HINSTANCE hInstance			インスタンスハンドル
 * @paramm	HINSTANCE hPrevInstance		未使用(常にNULL)：Win16時代の名残
 * @param	LPSTR lpCmdLine				コマンドライン引数
 * @paramL	int nShowCmd				ウィンドウの表示方法
 * @return	int リターンコード
 */
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd) {
	LoadLibrary("RICHED20.DLL");

	// UserAgent生成
	static OSVERSIONINFOEX os;
	GetVersion2(&os);
	UserAgent = (string)"Mozilla/5.0 (" + APPNAME + "/"
		+ APPVERSION + "/" + MAKER
		+ ", Windows NT " + to_string(os.dwMajorVersion) + "."
		+ to_string(os.dwMinorVersion) + ")";

	// pahooGeocodeオブジェクト
	pGC = new pahooGeocode(APPNAME);
	// pahooHeartRailsExpressオブジェクト
	pHR = new pahooHeartRailsExpress();

	// メイン・ダイアログ
	HWND hDlg = CreateDialog(hInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, (DLGPROC)processMain);
	hInst = hInstance;
	hParent = hDlg;
	// メイン・ダイアログを初期化する．
	initDialog(hDlg);

	// オブジェクト解放
	delete pGC;
	delete pHR;

	return 0;
}

/*
 ** バージョンアップ履歴 =====================================================
 *
 * @version 2.2.3 2026/02/28 使用ライブラリ更新
 * @version 2.2.2 2025/11/08 使用ライブラリ更新
 * @version 2.2.1 2025/07/26 使用ライブラリ更新
 * @version 2.2.0 2025/03/22 Leafletアクセス可否チェック追加，使用ライブラリ更新
 * @version 2.1.2 2024/11/30 使用ライブラリ更新
 * @version 2.1.1 2024/08/17 使用ライブラリ更新
 * @version 2.1.0 2024/05/03 API入力処理を改良
 * @version 2.0.0 2024/04/28 Edgeブラウザ対応，64ビット対応
 * @version 1.1.4 2024/03/30 使用ライラリ更新
 * @version 1.1.3 2023/11/23 使用ライラリ更新
 * @version 1.1.2 2023/07/08 使用ライラリ更新
 * @version 1.1.1 2023/04/01 使用ライラリ更新
 * @version 1.1.0 2022/09/23 UserAgent追加，ウィンドウ位置保存，ライブラリ更新
 * @version 1.0   2020/10/03 初版
 */
